// JavaScript Document
/* handle admin options and dependencies */

jQuery(document).ready(function(){
	// add your jquery code here
	/* show hide options regarding user selection */
	if( jQuery( '#sfp_allow_img_upload' ).is( ':checked' ) ) jQuery( '#sh_limit_img_upload' ).show();
	else jQuery( '#sh_limit_img_upload' ).hide();
	if( jQuery( '#sfp_allow_img_upload' ).is( ':checked' ) ) jQuery( '#sh_limit_file_size' ).show();
	else jQuery( '#sh_limit_file_size' ).hide();
	if( jQuery( '#sfp_enable_gmaps' ).is( ':checked' ) ) jQuery( '#sfp-gmaps-api' ).show();
	else jQuery( '#sfp-gmaps-api' ).hide();
	jQuery( '#sfp_allow_img_upload' ).click( function() {
		jQuery( '#sh_limit_img_upload' ).toggle();
		jQuery( '#sh_limit_file_size' ).toggle();
	} );
	jQuery( '#sfp_enable_gmaps' ).click( function() {
		jQuery( '#sfp-gmaps-api' ).toggle();
	} );
	/* show hide payment options regarding user selection */
	if( jQuery( '#publish_type' ).val() == 'payed' || jQuery( '#publish_type' ).val() == 'optional' ) {
		
		if( jQuery( '#publish_type' ).val() == 'optional' ) {
			jQuery( '#sponsored-fee-row' ).show();
			jQuery( '#regular-fee-row' ).hide();
		} else {
			jQuery( '#sponsored-fee-row' ).show();
			jQuery( '#regular-fee-row' ).show();
		}
		
		jQuery( '#payment_opts' ).show();
		
	} else jQuery( '#payment_opts' ).hide();
	
	jQuery( '#publish_type' ).change( function() {
		
		if( jQuery( '#publish_type' ).val() == 'payed' || jQuery( '#publish_type' ).val() == 'optional' ) {
			
			if( jQuery( '#publish_type' ).val() == 'optional' ) {
				jQuery( '#sponsored-fee-row' ).show();
				jQuery( '#regular-fee-row' ).hide();
			} else {
				jQuery( '#sponsored-fee-row' ).show();
				jQuery( '#regular-fee-row' ).show();
			}
			
			jQuery( '#payment_opts' ).show();
			
		} else jQuery( '#payment_opts' ).hide();
	 } );
	
	//validate plugin option form 
  	jQuery( '#sofa_front_post_options' ).validate( {
		rules: {
			sfp_limit_img_upload: {
				required: false,
				number: true,
				min: 0
			},
			sfp_limit_file_size: {
				required: false,
				number: true,
				min: 0.1
			}, 
			sfp_expire: {
				required: true,
				number: true,
				min: 0
			},
			sfp_fee: {
				required: false,
				number: true,
				min: 0.1
			},
			sfp_sponsored_fee: {
				required: false,
				number: true,
				min: 0.1
			},
			sfp_drop_due_to_pays: {
				required: true,
				number: true,
				min: 1
			}
		},
		messages: {
			sfp_limit_img_upload: {
				required: sfp_limits.required,
				number: sfp_limits.number,
				min: sfp_limits.min
			}, 
			sfp_limit_file_size: {
				required: sfp_limits.required,
				number: sfp_limits.number,
				less: sfp_limits.less
			},
			sfp_expire: {
				required: sfp_limits.required,
				number: sfp_limits.number,
				min: sfp_limits.min
			},
			sfp_fee: {
				required: sfp_limits.required,
				number: sfp_limits.number,
				less: sfp_limits.less
			},
			sfp_sponsored_fee: {
				required: sfp_limits.required,
				number: sfp_limits.number,
				less: sfp_limits.less
			},
			sfp_drop_due_to_pays: {
				required: sfp_limits.required,
				number: sfp_limits.number,
				one: sfp_limits.one
			}
		}

	});
	
});